Option Explicit On
Option Strict Off

Imports System.Runtime.InteropServices

Module EPX64S

    ' Device status (Return codes)
    Public Const EPX64S_OK As Integer = 0
    Public Const EPX64S_INVALID_HANDLE As Integer = 1
    Public Const EPX64S_DEVICE_NOT_FOUND As Integer = 2
    Public Const EPX64S_DEVICE_NOT_OPENED As Integer = 3
    Public Const EPX64S_OTHER_ERROR As Integer = 4
    Public Const EPX64S_COMMUNICATION_ERROR As Integer = 5
    Public Const EPX64S_INVALID_PARAMETER As Integer = 6

    ' Constants
    Public Const EPX64S_PORT0 As Byte = &H1
    Public Const EPX64S_PORT1 As Byte = &H2
    Public Const EPX64S_PORT2 As Byte = &H4
    Public Const EPX64S_PORT3 As Byte = &H8
    Public Const EPX64S_PORT4 As Byte = &H10
    Public Const EPX64S_PORT5 As Byte = &H20
    Public Const EPX64S_PORT6 As Byte = &H40
    Public Const EPX64S_PORT7 As Byte = &H80

    ' Function definitions
    Public Declare Function EPX64S_GetNumberOfDevices Lib "EPX64S.dll" (ByRef Number As Integer) As Integer
    Public Declare Function EPX64S_GetSerialNumber Lib "EPX64S.dll" (ByVal Index As Integer, ByRef SerialNumber As Integer) As Integer
    Public Declare Function EPX64S_Open Lib "EPX64S.dll" (ByRef Handle As System.IntPtr) As Integer
    Public Declare Function EPX64S_OpenBySerialNumber Lib "EPX64S.dll" (ByVal SerialNumber As Integer, ByRef Handle As System.IntPtr) As Integer
    Public Declare Function EPX64S_Close Lib "EPX64S.dll" (ByVal Handle As System.IntPtr) As Integer
    Public Declare Function EPX64S_SetDirection Lib "EPX64S.dll" (ByVal Handle As System.IntPtr, ByVal Direction As Byte) As Integer
    Public Declare Function EPX64S_GetDirection Lib "EPX64S.dll" (ByVal Handle As System.IntPtr, ByRef Direction As Byte) As Integer
    Public Declare Function EPX64S_OutputPort Lib "EPX64S.dll" (ByVal Handle As System.IntPtr, ByVal Port As Byte, ByVal Value As Byte) As Integer
    Public Declare Function EPX64S_InputPort Lib "EPX64S.dll" (ByVal Handle As System.IntPtr, ByVal Port As Byte, ByRef Value As Byte) As Integer

End Module
